


import machine
import time
import neopixel

pixel_count = 30 

class Player:
  def __init__(self, pos, color):
    self.pos = pos
    self.previous_pos = pos
    self.color = color
    self.speed = 0.01
  
  def draw(self, leds):
    leds[int(self.previous_pos)] = (0,0,0)
    leds[int(self.pos)] = self.color
    
  def update(self, dt):
    global pixel_count
    self.previous_pos = self.pos
    self.pos += self.speed * dt
    print("Playerpos:", self.pos)
    
    #bounce of walls
    if self.pos >= pixel_count:
      self.pos = pixel_count - 1
      self.speed = -self.speed
    
    if self.pos < 0:
      self.pos = 0
      self.speed = -self.speed

def check_player_collision_simple(p1, p2):
  if abs(p1.pos - p2.pos) < 1:
    print("Collision!")
    
leds = neopixel.NeoPixel(machine.Pin(4), pixel_count)

green = (0, 100, 0)
purple = (120, 0, 100)
p1 = Player(5, green)
p2 = Player(pixel_count - 5, purple)
last_time = time.ticks_ms()

while True:
  dt = time.ticks_diff(time.ticks_ms(), last_time)
  last_time = time.ticks_ms()
  print("time passed:", dt)

  p1.update(dt)
  p2.update(dt)
  
  check_player_collision_simple(p1, p2)
  
  p1.draw(leds)
  p2.draw(leds)
  leds.write()
  
  time.sleep_ms(50)


